﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.9
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Type myMarkerInfo(lat As Double,lng As Double, name As String,runaway As Boolean,hidden As Boolean,Informant As Boolean, Arrest As Boolean,TimeStop As Boolean )

	Private fx As JFX
	Private frm As Form
	Private gmap As GoogleMap
	Private ModCallback As Object
	Private modEvent As String
	Private ptLat As Double
	Private ptLong As Double
	Private thisMarker As Marker
	Private OtherMarkers As List
	Private allMarkers As List
	Private GeoFence As List
	
	
	Private btnJumpto As Button
	Private btnSelect As Button
	Private pnMap As Pane
	Private tfMapLat As TextField
	Private tfMapLong As TextField
End Sub

Sub show(Callee As Object,evtName As String,ptLa As Double,ptLo As Double,MarkerList As List,GeoF As List)
	ModCallback = Callee
	modEvent = evtName
	ptLat = ptLa
	ptLong = ptLo
	OtherMarkers = MarkerList
	GeoFence = GeoF
	
	If Not(frm.IsInitialized) Then
		frm.Initialize("MapChoosePlace",600,600)
		frm.RootPane.LoadLayout("MapPointChooser")
		
		Private opt As MapOptions
		opt.StreetViewControl = False
		opt.OverviewMapControl = False
'		gmap.Initialize2("gmap",opt,Starter.GoogleMapsAPIKey)
		gmap.Initialize("gmap",opt)
		pnMap.AddNode(gmap.AsPane,0,0,pnMap.Width,pnMap.Height)
		btnJumpto.Enabled = False
		btnSelect.Enabled = False
		
		allMarkers.Initialize
	Else ' jump to the point 
		gmap_Ready
	End If
	frm.show
End Sub

Sub AddOtherMarkers(ml As List)
	' DO nothing in this example
'	Log("Other Markers = " & ml.Size)
'	If (ml.IsInitialized And ml.Size > 0) Then
'		For Each mi As myMarkerInfo In ml
'		Private imgstr As String
'		If (mi.hidden) Then
'			imgstr = "yellowmapdot.png"
'		else if (mi.runaway) Then
'			imgstr = "bluemapdot.png"
'		Else if (mi.Arrest) Then
'			imgstr = "A_pinkmapdot.png"
'		Else if (mi.Informant) Then
'			imgstr = "I_pinkmapdot.png"
'		else if (mi.TimeStop) Then
'			imgstr = "T_pinkmapdot.png"
'		Else
'			imgstr = "pinkmapdot.png"
'		End If
'		allMarkers.Add(gmap.AddMarker2(mi.lat,mi.lng,mi.name,File.GetUri(File.DirAssets,imgstr)))
'		Next
'	End If
End Sub

Sub RemoveAllMarkers(mrks As List)
	If (mrks.IsInitialized And mrks.Size > 0) Then
		For Each mi As Marker In mrks
			gmap.RemoveMarker(mi)
		Next
	End If	
End Sub

Sub MapChoosePlace_Closed
	gmap.RemoveMarker(thisMarker)
	RemoveAllMarkers(allMarkers)
	allMarkers.Clear
End Sub


Sub gmap_Ready
'	fx.Msgbox(frm,"Setting location to map screen" & CRLF & "lat:" & ptLat & CRLF & "long" & ptLong,Starter.gstrApplicationTitle)

	btnSelect.Enabled = True
	btnJumpto.Enabled = True
	gmap.MapType = gmap.MAP_TYPE_NORMAL
	tfMapLat.Text = ptLat
	tfMapLong.Text = ptLong
	Private cp As CameraPosition

	If (OtherMarkers.IsInitialized And OtherMarkers.Size > 0) Then
		AddOtherMarkers(OtherMarkers)
	End If
	If (GeoFence.IsInitialized And GeoFence.Size > 0) Then
		ShowPolygon(GeoFence)
	End If
	cp.Initialize(ptLat,ptLong,16)
	gmap.MoveCamera(cp)
	thisMarker = gmap.AddMarker(ptLat,ptLong,"Selected Point")
End Sub

Sub ShowPolygon(myGeoFence As List)
	Private geol As List
	geol.Initialize
	For Each pt As LatLng In myGeoFence
		Private pnt2 As LatLng
		pnt2.Initialize(pt.Latitude,pt.Longitude)
		geol.Add(pnt2)
	Next
	gmap.AddPolygon(geol,0,fx.Colors.Green,fx.Colors.Magenta,0.3)

End Sub

Sub gmap_Click (Point As LatLng)
	
	Log("point Clicker")
	Private mapZoom As Float
	Private MapCenter As LatLng
	Private cp As CameraPosition
	
	gmap.RemoveMarker(thisMarker)
	tfMapLat.Text = Point.Latitude
	tfMapLong.Text = Point.Longitude
	thisMarker = gmap.AddMarker(Point.Latitude,Point.Longitude,"Selected Point")
	'Force re-draw of map to remove old marker icon
	mapZoom = gmap.CameraPosition.Zoom
	MapCenter = gmap.CameraPosition.Target
	cp.Initialize(MapCenter.Latitude, MapCenter.Longitude, 10 )
	gmap.MoveCamera(cp)
	cp.Initialize(MapCenter.Latitude, MapCenter.Longitude, mapZoom )
	gmap.MoveCamera(cp)
End Sub

Sub pnMap_Resize (Width As Double, Height As Double)
	gmap.AsPane.SetSize(Width, Height)
End Sub


Sub btnSelect_Action
	Private ll, lo As Double
	ll = tfMapLat.Text
	lo = tfMapLong.Text
'	fx.Msgbox(frm,"Sending location to game using event"& modEvent & CRLF & "lat:" & ll & CRLF & "long" & lo,Starter.gstrApplicationTitle)

	CallSubDelayed3(ModCallback,modEvent,ll,lo)
'	CallSub3(ModCallback,modEvent,ll,lo)
	frm.Close
End Sub

Sub btnJumpto_Action
	Private cp As CameraPosition
	Private ll, lo As Double

	ll = tfMapLat.Text
	lo = tfMapLong.Text
	cp.Initialize(ll,lo,14)
	gmap.MoveCamera(cp)
End Sub